Index: trunk/MagicSoft/Mars/mcalib/MHCalibrationChargeCam.cc
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MHCalibrationChargeCam.cc	(revision 4383)
+++ trunk/MagicSoft/Mars/mcalib/MHCalibrationChargeCam.cc	(revision 4389)
@@ -156,5 +156,9 @@
 const Float_t MHCalibrationChargeCam::fgTimeLowerLimit           = 1.;
 const Float_t MHCalibrationChargeCam::fgTimeUpperLimit           = 2.;
-const Int_t   MHCalibrationChargeCam::gkNumRefColours            = 7;
+// 1Led Green, 1 LED blue, 5 LEDs blue, 10 LEDs blue, 10 LEDs UV, CT1, 5Leds Green
+const Float_t MHCalibrationChargeCam::gkHiGainInnerRefLines[7]   = { 245., 323. , 1065., 1467., 180., 211. , 533.5};   
+const Float_t MHCalibrationChargeCam::gkHiGainOuterRefLines[7]   = { 217., 307.5, 932. , 1405., 167., 183.5, 405.5};
+const Float_t MHCalibrationChargeCam::gkLoGainInnerRefLines[7]   = { 20.8, 28.0 , 121. , 200.2, 16.5, 13.5 , 41.7 };
+const Float_t MHCalibrationChargeCam::gkLoGainOuterRefLines[7]   = { 18.9, 26.0 , 108.3, 198. , 14.0, 11.  , 42.  };
 // --------------------------------------------------------------------------
 //
@@ -181,50 +185,4 @@
   SetTimeUpperLimit();
 
-  gkHiGainInnerRefLines.Set(gkNumRefColours);
-  gkHiGainOuterRefLines.Set(gkNumRefColours);
-  gkLoGainInnerRefLines.Set(gkNumRefColours);
-  gkLoGainOuterRefLines.Set(gkNumRefColours);
-
-  // 1 LED green
-  gkHiGainInnerRefLines.AddAt(245. ,0);
-  gkHiGainOuterRefLines.AddAt(217. ,0);
-  gkLoGainInnerRefLines.AddAt(20.8 ,0);
-  gkLoGainOuterRefLines.AddAt(18.9 ,0);
-
-  // 1 LED blue
-  gkHiGainInnerRefLines.AddAt(323. ,1);
-  gkHiGainOuterRefLines.AddAt(307.5,1);
-  gkLoGainInnerRefLines.AddAt(28.0 ,1);
-  gkLoGainOuterRefLines.AddAt(26.0 ,1);
-
-  // 5 LEDs blue
-  gkHiGainInnerRefLines.AddAt(1065.,2);
-  gkHiGainOuterRefLines.AddAt(932. ,2);
-  gkLoGainInnerRefLines.AddAt(121. ,2);
-  gkLoGainOuterRefLines.AddAt(108.3,2);
-
-  // 10 LEDs blue
-  gkHiGainInnerRefLines.AddAt(1467.,3);
-  gkHiGainOuterRefLines.AddAt(1405.,3);
-  gkLoGainInnerRefLines.AddAt(200.2,3);
-  gkLoGainOuterRefLines.AddAt(198. ,3);
-
-  // 10 LEDs UV
-  gkHiGainInnerRefLines.AddAt(180.,4);
-  gkHiGainOuterRefLines.AddAt(167.,4);
-  gkLoGainInnerRefLines.AddAt(16.5,4);
-  gkLoGainOuterRefLines.AddAt(14.0,4);
-
-  // CT1
-  gkHiGainInnerRefLines.AddAt(211.,5);
-  gkHiGainOuterRefLines.AddAt(183.5,5);
-  gkLoGainInnerRefLines.AddAt(13.5,5);
-  gkLoGainOuterRefLines.AddAt(11.,5);
-
-  // 5 LEDs green
-  gkHiGainInnerRefLines.AddAt(533.5,6);
-  gkHiGainOuterRefLines.AddAt(405.5,6);
-  gkLoGainInnerRefLines.AddAt(41.7,6);
-  gkLoGainOuterRefLines.AddAt(42.,6);
 
 }
@@ -1002,5 +960,5 @@
 }
 
-void MHCalibrationChargeCam::DrawDataCheckPixel(MHCalibrationChargePix &pix, const TArrayF &refline)
+void MHCalibrationChargeCam::DrawDataCheckPixel(MHCalibrationChargePix &pix, const Float_t refline[])
 {
   
@@ -1050,8 +1008,8 @@
 
 
-void  MHCalibrationChargeCam::DisplayRefLines(const TH2D *hist, const TArrayF &refline) const
-{
-
-  TLine *green1 = new TLine(refline.At(0),0.,refline.At(0),hist->GetYaxis()->GetXmax());
+void  MHCalibrationChargeCam::DisplayRefLines(const TH2D *hist, const Float_t refline[]) const
+{
+
+  TLine *green1 = new TLine(refline[0],0.,refline[0],hist->GetYaxis()->GetXmax());
   green1->SetBit(kCanDelete);
   green1->SetLineColor(kGreen);
@@ -1060,5 +1018,5 @@
   green1->Draw();
 
-  TLine *green5 = new TLine(refline.At(6),0.,refline.At(6),hist->GetYaxis()->GetXmax());
+  TLine *green5 = new TLine(refline[6],0.,refline[6],hist->GetYaxis()->GetXmax());
   green5->SetBit(kCanDelete);
   green5->SetLineColor(8);
@@ -1067,5 +1025,5 @@
   green5->Draw();
 
-  TLine *blue1   = new TLine(refline.At(1),0.,refline.At(1),hist->GetYaxis()->GetXmax());
+  TLine *blue1   = new TLine(refline[1],0.,refline[1],hist->GetYaxis()->GetXmax());
   blue1->SetBit(kCanDelete);
   blue1->SetLineColor(007);
@@ -1074,5 +1032,5 @@
   blue1->Draw();
 
-  TLine *blue5   = new TLine(refline.At(2),0.,refline.At(2),hist->GetYaxis()->GetXmax());
+  TLine *blue5   = new TLine(refline[2],0.,refline[2],hist->GetYaxis()->GetXmax());
   blue5->SetBit(kCanDelete);
   blue5->SetLineColor(062);
@@ -1081,5 +1039,5 @@
   blue5->Draw();
 
-  TLine *blue10   = new TLine(refline.At(3),0.,refline.At(3),hist->GetYaxis()->GetXmax());
+  TLine *blue10   = new TLine(refline[3],0.,refline[3],hist->GetYaxis()->GetXmax());
   blue10->SetBit(kCanDelete);
   blue10->SetLineColor(004);
@@ -1088,5 +1046,5 @@
   blue10->Draw();
 
-  TLine *uv10    = new TLine(refline.At(4),0.,refline.At(4),hist->GetYaxis()->GetXmax());
+  TLine *uv10    = new TLine(refline[4],0.,refline[4],hist->GetYaxis()->GetXmax());
   uv10->SetBit(kCanDelete);
   uv10->SetLineColor(106);
@@ -1095,5 +1053,5 @@
   uv10->Draw();
 
-  TLine *ct1    = new TLine(refline.At(5),0.,refline.At(5),hist->GetYaxis()->GetXmax());
+  TLine *ct1    = new TLine(refline[5],0.,refline[5],hist->GetYaxis()->GetXmax());
   ct1->SetBit(kCanDelete);
   ct1->SetLineColor(006);
Index: trunk/MagicSoft/Mars/mcalib/MHCalibrationChargeCam.h
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MHCalibrationChargeCam.h	(revision 4383)
+++ trunk/MagicSoft/Mars/mcalib/MHCalibrationChargeCam.h	(revision 4389)
@@ -23,10 +23,9 @@
   static const Float_t fgTimeLowerLimit;             //! Default for fTimeLowerLimit    (now set to: 1.) 
   static const Float_t fgTimeUpperLimit;             //! Default for fTimeUpperLimit    (now set to: 2.)
-  static const Int_t   gkNumRefColours;
   
-  TArrayF gkHiGainInnerRefLines;
-  TArrayF gkHiGainOuterRefLines;
-  TArrayF gkLoGainInnerRefLines;
-  TArrayF gkLoGainOuterRefLines;
+  static const Float_t gkHiGainInnerRefLines[7];
+  static const Float_t gkHiGainOuterRefLines[7];
+  static const Float_t gkLoGainInnerRefLines[7];
+  static const Float_t gkLoGainOuterRefLines[7];
   
   Float_t fTimeLowerLimit;            // Limit dist. to first signal slice (in units of FADC slices) 
@@ -48,6 +47,6 @@
   void   FinalizeBadPixels();
 
-  void   DrawDataCheckPixel(MHCalibrationChargePix &pix, const TArrayF &refline);
-  void   DisplayRefLines(const TH2D *hist, const TArrayF &refline) const;
+  void   DrawDataCheckPixel(MHCalibrationChargePix &pix, const Float_t refline[]);
+  void   DisplayRefLines(const TH2D *hist, const Float_t refline[]) const;
   
 public: